// GMEDoc.h : interface of the CGMEDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_GMEDOC_H__BD235B53_BD3F_11D3_91E2_00104B98EAD9__INCLUDED_)
#define AFX_GMEDOC_H__BD235B53_BD3F_11D3_91E2_00104B98EAD9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "GMEStd.h"
#include "GuiObject.h"
#include "GMEOLEData.h"
//#include "MGAUtil_i.h"

class CGMEDoc : public CDocument
{
protected: // create from serialization only
	CGMEDoc();
	DECLARE_DYNCREATE(CGMEDoc)

// Attributes
public:
	static CGMEDoc *theInstance;
	CToolBar modeBar;
	GMEModeCode editMode;

	CComPtr<IMgaModel> nextToView;
	CComPtr<IMgaFCO> initialCenterObj;
	CString nextAspect;
	CComPtr<IMgaResolver> resolver;

// Operations
public:
	GMEModeCode GetEditMode()								{ return editMode; }
	void InvalidateAllViews(bool thorough = false, bool fullAutoRoute = false);
	void ResetAllViews();
	void ViewModeChange();
	CGMEView *FindView(CComPtr<IMgaModel> model);
	void SetNextToView(CComPtr<IMgaModel> &model,CString aspName, CComPtr<IMgaFCO> &centerObj)			{ nextToView = model; nextAspect = aspName; initialCenterObj = centerObj;}
	void ShowObject(CComPtr<IUnknown> alienObject);
	void ShowObject(LPCTSTR objectID);
	void ResetNextToView()													{ nextToView = 0; }
	void ChangeAspects(CString aspName);

	static bool CreateFcoList(CGuiObjectList* list,CComPtr<IMgaFCOs> &fcos,CGMEView *view);
	static bool CreateFcoList2(CGuiObjectList* list,CComPtr<IMgaFCOs> &fcos,CGMEView *view, long *howmany, bool* array[8]);
	static bool CreateAnnotationList(CGuiAnnotatorList* list,CComPtr<IMgaRegNodes> &anns,CGMEView *view);
	static void CopyClosureToClipboard(CGuiObjectList* list,CGuiAnnotatorList *annList,CGMEDataDescriptor* desc,CGMEView *view);
	static void CopySmartToClipboard(CGuiObjectList* list,CGuiAnnotatorList *annList,CGMEDataDescriptor* desc,CGMEView *view);
	static void CopyToClipboard(CGuiObjectList* list,CGuiAnnotatorList *annList,CGMEDataDescriptor* desc,CGMEView *view);
	static DROPEFFECT DoDragDrop(CGuiObjectList* list, CGuiAnnotatorList *annList, CGMEDataDescriptor* desc,
									DWORD dwEffects, LPCRECT lpRectStartDrag,CGMEView *view);
	static DROPEFFECT DoDragDrop(CGuiObject *guiObj, CGMEDataDescriptor* desc,
									DWORD dwEffects, LPCRECT lpRectStartDrag);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CGMEDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void OnCloseDocument(bool suppressErrors = false);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CGMEDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CGMEDoc)
	afx_msg void OnModeAutoconnect();
	afx_msg void OnUpdateModeAutoconnect(CCmdUI* pCmdUI);
	afx_msg void OnModeDisconnect();
	afx_msg void OnUpdateModeDisconnect(CCmdUI* pCmdUI);
	afx_msg void OnModeEdit();
	afx_msg void OnUpdateModeEdit(CCmdUI* pCmdUI);
	afx_msg void OnModeSet();
	afx_msg void OnUpdateModeSet(CCmdUI* pCmdUI);
	afx_msg void OnModeVisualize();
	afx_msg void OnUpdateModeVisualize(CCmdUI* pCmdUI);
	afx_msg void OnModeZoom();
	afx_msg void OnUpdateModeZoom(CCmdUI* pCmdUI);
	afx_msg void OnUpdateFileClose(CCmdUI* pCmdUI);
	afx_msg void OnViewRefresh();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_GMEDOC_H__BD235B53_BD3F_11D3_91E2_00104B98EAD9__INCLUDED_)
