// GmeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MgaUtil.h"
#include "GmeDlg.h"
#include "DirDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGmeDlg dialog


CGmeDlg::CGmeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGmeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGmeDlg)
	m_iconpath = _T("");
	m_sysiconpath = _T("");
	m_multipleview = FALSE;
	m_enablelogging = TRUE;
	m_autosave_dir = _T("");
	m_autosave_enabled = FALSE;
	m_autosave_freq = 0;
	m_autosave_dest = -1;
	m_ext_enable = FALSE;
	m_ext_editor = _T("");
	m_labelavoidance = FALSE;
	//}}AFX_DATA_INIT
}


void CGmeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGmeDlg)
	DDX_Text(pDX, IDC_ICONPATH, m_iconpath);
	DDX_Text(pDX, IDC_SYSICONPATH, m_sysiconpath);
	DDX_Check(pDX, IDC_MULTIPLE_OPEN, m_multipleview);
	DDX_Check(pDX, IDC_EVENT_LOGGING, m_enablelogging);
	DDX_Text(pDX, IDC_AUTOSAVE_DIR, m_autosave_dir);
	DDX_Check(pDX, IDC_AUTOSAVE_ENABLED, m_autosave_enabled);
	DDX_Text(pDX, IDC_AUTOSAVE_FREQ, m_autosave_freq);
	DDX_Radio(pDX, IDC_AUTOSAVE_SAME_DIR, m_autosave_dest);
	DDX_Check(pDX, IDC_EXT_ENABLE, m_ext_enable);
	DDX_Text(pDX, IDC_EXT_EDITOR, m_ext_editor);
	DDX_Check(pDX, IDC_LABELAVOIDANCE, m_labelavoidance);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGmeDlg, CDialog)
	//{{AFX_MSG_MAP(CGmeDlg)
	ON_BN_CLICKED(IDC_ADDICONPATH, OnAddIconPath)
	ON_BN_CLICKED(IDC_ADDSYSICONPATH, OnAddsysiconpath)
	ON_BN_CLICKED(IDC_AUTOSAVE_DIR_BUTTON, OnAutosaveDirButton)
	ON_BN_CLICKED(IDC_AUTOSAVE_ENABLED, OnAutosaveEnabled)
	ON_BN_CLICKED(IDC_AUTOSAVE_SAME_DIR, OnAutosaveSameDir)
	ON_BN_CLICKED(IDC_AUTOSAVE_DEDICATED_DIR, OnAutosaveDedicatedDir)
	ON_BN_CLICKED(IDC_EXT_BUTTON, OnExtButton)
	ON_BN_CLICKED(IDC_EXT_ENABLE, OnExtEnable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGmeDlg message handlers

static char icofilter[] = "Icon files (*.ico;*.bmp)|*.ico;*.bmp|All Files (*.*)|*.*||";
static char bakfilter[] = "Backup files (*.bak)|*.bak|All Files (*.*)|*.*||";
static char exefilter[] = "Executable files (*.exe)|*.exe|All Files (*.*)|*.*||";

void CGmeDlg::OnAddIconPath() 
{
	CDirDialog dlg(NULL, icofilter, NULL);

	dlg.DoModal();

	GetDlgItem(IDC_ICONPATH)->GetWindowText(m_iconpath);

	CString path = dlg.GetPath();
	if( !m_iconpath.IsEmpty() && !path.IsEmpty() )
		m_iconpath += ';';

	m_iconpath += path;

	GetDlgItem(IDC_ICONPATH)->SetWindowText(m_iconpath);
}


void CGmeDlg::OnAddsysiconpath() 
{
	CDirDialog dlg(NULL, icofilter, NULL);

	dlg.DoModal();

	GetDlgItem(IDC_SYSICONPATH)->GetWindowText(m_sysiconpath);

	CString path = dlg.GetPath();
	if( !m_sysiconpath.IsEmpty() && !path.IsEmpty() )
		m_sysiconpath += ';';

	m_sysiconpath += path;

	GetDlgItem(IDC_SYSICONPATH)->SetWindowText(m_sysiconpath);
}

BOOL CGmeDlg::OnInitDialog() 
{
	MSGTRY
	{
		ASSERT( registrar == NULL );
		COMTHROW( registrar.CoCreateInstance(OLESTR("MGA.MgaRegistrar")) );
		ASSERT( registrar != NULL );

		// Icons
		COMTHROW( registrar->get_IconPath(REGACCESS_USER, PutOut(m_iconpath)) );
		COMTHROW( registrar->get_IconPath(REGACCESS_SYSTEM, PutOut(m_sysiconpath)) );

		m_isave = m_iconpath;
		m_sysisave = m_sysiconpath;
		if(registrar->put_IconPath(REGACCESS_TEST, CComBSTR("XXX")) != S_OK) {
			GetDlgItem(IDC_SYSICONPATH)->EnableWindow(false);
			GetDlgItem(IDC_ADDSYSICONPATH)->EnableWindow(false);
		}

		// Multiview
		VARIANT_BOOL enabledmv;
		COMTHROW( registrar->get_ShowMultipleView(REGACCESS_USER, &enabledmv) );
		m_multipleview = (enabledmv == VARIANT_FALSE) ? FALSE : TRUE;

		// Logging
		VARIANT_BOOL enablelogging;
		COMTHROW( registrar->get_EventLoggingEnabled(REGACCESS_USER, &enablelogging) );
		m_enablelogging = (enablelogging == VARIANT_FALSE) ? FALSE : TRUE;

		// Autosave
		VARIANT_BOOL autosaveenable;
		COMTHROW( registrar->get_AutosaveEnabled(REGACCESS_USER, &autosaveenable) );
		m_autosave_enabled = (autosaveenable == VARIANT_FALSE) ? FALSE : TRUE;

		long autosavefreq;
		COMTHROW( registrar->get_AutosaveFreq(REGACCESS_USER, &autosavefreq) );
		m_autosave_freq = (int)autosavefreq;

		VARIANT_BOOL autosaveusedir;
		COMTHROW( registrar->get_AutosaveUseDir(REGACCESS_USER, &autosaveusedir) );
		m_autosave_dest = (autosaveusedir == VARIANT_FALSE) ? 0 : 1;

		COMTHROW( registrar->get_AutosaveDir(REGACCESS_USER, PutOut(m_autosave_dir)) );
		
		// External Editor
		VARIANT_BOOL extenable;
		COMTHROW( registrar->get_ExternalEditorEnabled(REGACCESS_USER, &extenable) );
		m_ext_enable = (extenable == VARIANT_FALSE) ? FALSE : TRUE;

		COMTHROW( registrar->get_ExternalEditor(REGACCESS_USER, PutOut(m_ext_editor)) );

		// Autorouter
		VARIANT_BOOL labelavoidance;
		COMTHROW( registrar->get_LabelAvoidance(REGACCESS_USER, &labelavoidance) );
		m_labelavoidance = (labelavoidance == VARIANT_FALSE) ? FALSE : TRUE;

	}
	MSGCATCH("Error while initializing GmeDlg",;)

	AutosaveControlManager();
	ExtControlManager();
	CDialog::OnInitDialog();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CGmeDlg::OnOK() 
{
	
	CDialog::OnOK();

	ASSERT( registrar != NULL );
	// Icons
	if(m_iconpath.Compare(m_isave)) COMTHROW( registrar->put_IconPath(REGACCESS_USER, PutInBstr(m_iconpath)) );
	if(m_sysiconpath.Compare(m_sysisave)) COMTHROW( registrar->put_IconPath(REGACCESS_SYSTEM, PutInBstr(m_sysiconpath)) );
	
	// Multiview
	VARIANT_BOOL enabledmv = (m_multipleview == FALSE) ? VARIANT_FALSE : VARIANT_TRUE;
	COMTHROW( registrar->put_ShowMultipleView(REGACCESS_USER, enabledmv) );
	
	// Logging
	VARIANT_BOOL enablelogging = (m_enablelogging == FALSE) ? VARIANT_FALSE : VARIANT_TRUE;
	COMTHROW( registrar->put_EventLoggingEnabled(REGACCESS_USER, enablelogging) );

	// Autosave
	VARIANT_BOOL autosaveenable = (m_autosave_enabled == FALSE) ? VARIANT_FALSE : VARIANT_TRUE;
	COMTHROW( registrar->put_AutosaveEnabled(REGACCESS_USER, autosaveenable) );

	long autosavefreq = m_autosave_freq;
	COMTHROW( registrar->put_AutosaveFreq(REGACCESS_USER, autosavefreq) );

	VARIANT_BOOL autosaveusedir = (m_autosave_dest == 1) ? VARIANT_TRUE : VARIANT_FALSE;
	COMTHROW( registrar->put_AutosaveUseDir(REGACCESS_USER, autosaveusedir) );

	COMTHROW( registrar->put_AutosaveDir(REGACCESS_USER, PutInBstr(m_autosave_dir)) );

	// External Editor
	VARIANT_BOOL extenable = (m_ext_enable == FALSE) ? VARIANT_FALSE : VARIANT_TRUE;
	COMTHROW( registrar->put_ExternalEditorEnabled(REGACCESS_USER, extenable) );

	COMTHROW( registrar->put_ExternalEditor(REGACCESS_USER, PutInBstr(m_ext_editor)) );

	// Autorouter
	VARIANT_BOOL labelavoidance = (m_labelavoidance == FALSE) ? VARIANT_FALSE : VARIANT_TRUE;
	COMTHROW( registrar->put_LabelAvoidance(REGACCESS_USER, labelavoidance) );
}



void CGmeDlg::OnAutosaveDirButton() 
{
	CDirDialog dlg(NULL, bakfilter, NULL);

	dlg.DoModal();
	UpdateData(TRUE);
	m_autosave_dir = dlg.GetPath();
	UpdateData(FALSE);
}

void CGmeDlg::OnAutosaveEnabled() 
{
	UpdateData(TRUE);
	AutosaveControlManager();
}

void CGmeDlg::OnAutosaveSameDir() 
{
	UpdateData(TRUE);
	AutosaveControlManager();
}

void CGmeDlg::OnAutosaveDedicatedDir() 
{
	UpdateData(TRUE);
	AutosaveControlManager();
}

void CGmeDlg::AutosaveControlManager()
{
	// NOTE: we assume, that the exchange data members are
	// holding valid data. So, please call UpdateData if needed 
	// prior calling this

	BOOL freqEnabled = FALSE;
	BOOL sameDirEnabled = FALSE;
	BOOL dedicatedDirEnabled = FALSE;
	BOOL dirEnabled = FALSE;
	BOOL dirButtonEnabled = FALSE;

	if (m_autosave_enabled) {
		freqEnabled = TRUE;
		sameDirEnabled = TRUE;
		dedicatedDirEnabled = TRUE;
		if (m_autosave_dest == 1) {
			dirEnabled = TRUE;
			dirButtonEnabled = TRUE;
		}
	}

	GetDlgItem(IDC_AUTOSAVE_FREQ)->EnableWindow(freqEnabled);
	GetDlgItem(IDC_AUTOSAVE_SAME_DIR)->EnableWindow(sameDirEnabled);
	GetDlgItem(IDC_AUTOSAVE_DEDICATED_DIR)->EnableWindow(dedicatedDirEnabled);
	GetDlgItem(IDC_AUTOSAVE_DIR)->EnableWindow(dirEnabled);
	GetDlgItem(IDC_AUTOSAVE_DIR_BUTTON)->EnableWindow(dirButtonEnabled);
}

void CGmeDlg::ExtControlManager()
{
	// NOTE: we assume, that the exchange data members are
	// holding valid data. So, please call UpdateData if needed 
	// prior calling this
	GetDlgItem(IDC_EXT_EDITOR)->EnableWindow(m_ext_enable);
	GetDlgItem(IDC_EXT_BUTTON)->EnableWindow(m_ext_enable);
}

void CGmeDlg::OnExtButton() 
{
	UpdateData(TRUE);
	CFileDialog dlg(TRUE, NULL, m_ext_editor, OFN_HIDEREADONLY, exefilter, NULL);
	if (dlg.DoModal() == IDOK) {
		m_ext_editor = dlg.GetPathName();
		UpdateData(FALSE);
	}
}

void CGmeDlg::OnExtEnable() 
{
	UpdateData(TRUE);
	ExtControlManager();
}
